import oscP5.*;
import netP5.*;

OscP5 oscP5;
NetAddress dest;

boolean gameStart = false;

float x = 150;
float y = 150;
float speedX = 7;
float speedY = 6;
int leftColor = 50;
int rightColor = 50;
int diam;
int rectSize = 100;
float diamHit;


void setup() {
  size(640, 480);
  noStroke();
  smooth();
  ellipseMode(CENTER);
  
  /* start oscP5, listening for incoming messages at port 12000 */
  oscP5 = new OscP5(this,9000);
  dest = new NetAddress("127.0.0.1",6448);
}

void draw() { 
  background(255);

  fill(200,50,128);
  diam = 20;
  ellipse(x, y, diam, diam);

  fill(leftColor);
  rect(0, 0, 20, height);
  fill(rightColor);
  rect(width-30, mouseY-rectSize/2, 10, rectSize);


  if (gameStart) {

    x = x + speedX;
    y = y + speedY;

    // if ball hits movable bar, invert X direction and apply effects
    if ( x > width-30 && x < width -20 && y > mouseY-rectSize/2 && y < mouseY+rectSize/2 ) {
      speedX = speedX * -1;
      x = x + speedX;
      rightColor = 0;
    } 

    // if ball hits wall, change direction of X
    else if (x < 25) {
      speedX = speedX * -1.1;
      x = x + speedX;
      leftColor = 0;
    }

    else {     
      leftColor = 50;
      rightColor = 50;
    }
    // resets things if you lose
    if (x > width) { 
      gameStart = false;
      x = 150;
      y = 150; 
      speedX = 7;
      speedY = 6;
      rectSize = 100;
    }


    // if ball hits up or down, change direction of Y   
    if ( y > height || y < 0 ) {
      speedY = speedY * -1;
      y = y + speedY;
    }
  }
  
  //Send the OSC message with box current position
  sendOsc();
}
void mousePressed() {
  gameStart = true;
}

void sendOsc() {
  OscMessage msg = new OscMessage("/wek/inputs");
  msg.add((float)x); 
  msg.add((float)y);
  oscP5.send(msg, dest);
}
                
